# API Reference

The Redux API surface is tiny. Redux defines a set of contracts for you to implement (such as [reducers](/glossary.md#reducer)) and provides a few helper functions to tie these contracts together.

This section documents the complete Redux API. Keep in mind that Redux is only concerned with managing the state. In a real app, you'll also want to use UI bindings like [react-redux](https://github.com/gaearon/react-redux).

## Top-Level Exports

* [createStore(reducer, \[preloadedState\], \[enhancer\])](/api-reference/createstore.md)
* [combineReducers(reducers)](/api-reference/combinereducers.md)
* [applyMiddleware(...middlewares)](/api-reference/applymiddleware.md)
* [bindActionCreators(actionCreators, dispatch)](/api-reference/bindactioncreators.md)
* [compose(...functions)](/api-reference/compose.md)

## Store API

* [Store](/api-reference/store.md)
  * [getState()](/api-reference/store.md#getState)
  * [dispatch(action)](/api-reference/store.md#dispatch)
  * [subscribe(listener)](/api-reference/store.md#subscribe)
  * [replaceReducer(nextReducer)](/api-reference/store.md#replaceReducer)

## Importing

Every function described above is a top-level export. You can import any of them like this:

### ES6

```javascript
import { createStore } from 'redux'
```

### ES5 (CommonJS)

```javascript
var createStore = require('redux').createStore
```

### ES5 (UMD build)

```javascript
var createStore = Redux.createStore
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://redux-ru.js.org/api-reference.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
